diff --git a/gcc/m2/mc-boot/GmcPretty.cc b/gcc/m2/mc-boot/GmcPretty.cc
index cd480325645..10b262b8979 100644
--- a/gcc/m2/mc-boot/GmcPretty.cc
+++ b/gcc/m2/mc-boot/GmcPretty.cc
@@ -38,9 +38,9 @@ Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcPretty_H
 #define _mcPretty_C
 
+#include "GmcPretty.h"
 #   include "GDynamicStrings.h"
 #   include "GStorage.h"
 
@@ -50,13 +50,7 @@ typedef struct mcPretty_writeLnProc_p mcPretty_writeLnProc;
 
 typedef struct mcPretty__T1_r mcPretty__T1;
 
-typedef mcPretty__T1 *mcPretty_pretty;
-
-typedef void (*mcPretty_writeProc_t) (char);
-struct mcPretty_writeProc_p { mcPretty_writeProc_t proc; };
-
-typedef void (*mcPretty_writeLnProc_t) (void);
-struct mcPretty_writeLnProc_p { mcPretty_writeLnProc_t proc; };
+typedef mcPretty__T1 *mcPretty_pretty__opaque;
 
 struct mcPretty__T1_r {
                         mcPretty_writeProc write_;
@@ -67,7 +61,7 @@ struct mcPretty__T1_r {
                         unsigned int curLine;
                         unsigned int curPos;
                         unsigned int indent;
-                        mcPretty_pretty stacked;
+                        mcPretty_pretty__opaque stacked;
                       };
 
 
@@ -162,20 +156,20 @@ extern "C" void mcPretty_raw (mcPretty_pretty p, DynamicStrings_String s);
    flushSpace -
 */
 
-static void flushSpace (mcPretty_pretty p);
+static void flushSpace (mcPretty_pretty__opaque p);
 
 /*
    flushIndent -
 */
 
-static void flushIndent (mcPretty_pretty p);
+static void flushIndent (mcPretty_pretty__opaque p);
 
 
 /*
    flushSpace -
 */
 
-static void flushSpace (mcPretty_pretty p)
+static void flushSpace (mcPretty_pretty__opaque p)
 {
   if (p->needsSpace)
     {
@@ -191,7 +185,7 @@ static void flushSpace (mcPretty_pretty p)
    flushIndent -
 */
 
-static void flushIndent (mcPretty_pretty p)
+static void flushIndent (mcPretty_pretty__opaque p)
 {
   unsigned int i;
 
@@ -215,7 +209,7 @@ static void flushIndent (mcPretty_pretty p)
 
 extern "C" mcPretty_pretty mcPretty_initPretty (mcPretty_writeProc w, mcPretty_writeLnProc l)
 {
-  mcPretty_pretty p;
+  mcPretty_pretty__opaque p;
 
   Storage_ALLOCATE ((void **) &p, sizeof (mcPretty__T1));
   p->write_ = w;
@@ -226,8 +220,8 @@ extern "C" mcPretty_pretty mcPretty_initPretty (mcPretty_writeProc w, mcPretty_w
   p->curLine = 0;
   p->seekPos = 0;
   p->indent = 0;
-  p->stacked = NULL;
-  return p;
+  p->stacked = static_cast<mcPretty_pretty__opaque> (NULL);
+  return static_cast<mcPretty_pretty> (p);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -239,11 +233,11 @@ extern "C" mcPretty_pretty mcPretty_initPretty (mcPretty_writeProc w, mcPretty_w
 
 extern "C" mcPretty_pretty mcPretty_dupPretty (mcPretty_pretty p)
 {
-  mcPretty_pretty q;
+  mcPretty_pretty__opaque q;
 
   Storage_ALLOCATE ((void **) &q, sizeof (mcPretty__T1));
-  (*q) = (*p);
-  return q;
+  (*q) = (*static_cast<mcPretty_pretty__opaque> (p));
+  return static_cast<mcPretty_pretty> (q);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -256,10 +250,10 @@ extern "C" mcPretty_pretty mcPretty_dupPretty (mcPretty_pretty p)
 
 extern "C" void mcPretty_killPretty (mcPretty_pretty *p)
 {
-  (*p) = NULL;
-  return ;
+  (*p) = static_cast<mcPretty_pretty> (NULL);
+  return;
   Storage_DEALLOCATE ((void **) &(*p), sizeof (mcPretty__T1));
-  (*p) = NULL;
+  (*p) = static_cast<mcPretty_pretty> (NULL);
 }
 
 
@@ -269,11 +263,11 @@ extern "C" void mcPretty_killPretty (mcPretty_pretty *p)
 
 extern "C" mcPretty_pretty mcPretty_pushPretty (mcPretty_pretty p)
 {
-  mcPretty_pretty q;
+  mcPretty_pretty__opaque q;
 
-  q = mcPretty_dupPretty (p);
-  q->stacked = p;
-  return q;
+  q = static_cast<mcPretty_pretty__opaque> (mcPretty_dupPretty (p));
+  q->stacked = static_cast<mcPretty_pretty__opaque> (p);
+  return static_cast<mcPretty_pretty> (q);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -285,16 +279,16 @@ extern "C" mcPretty_pretty mcPretty_pushPretty (mcPretty_pretty p)
 
 extern "C" mcPretty_pretty mcPretty_popPretty (mcPretty_pretty p)
 {
-  mcPretty_pretty q;
-
-  q = p->stacked;
-  q->needsIndent = p->needsIndent;
-  q->needsSpace = p->needsSpace;
-  q->curPos = p->curPos;
-  q->seekPos = p->seekPos;
-  q->curLine = p->curLine;
+  mcPretty_pretty__opaque q;
+
+  q = static_cast<mcPretty_pretty__opaque> (p)->stacked;
+  q->needsIndent = static_cast<mcPretty_pretty__opaque> (p)->needsIndent;
+  q->needsSpace = static_cast<mcPretty_pretty__opaque> (p)->needsSpace;
+  q->curPos = static_cast<mcPretty_pretty__opaque> (p)->curPos;
+  q->seekPos = static_cast<mcPretty_pretty__opaque> (p)->seekPos;
+  q->curLine = static_cast<mcPretty_pretty__opaque> (p)->curLine;
   mcPretty_killPretty (&p);
-  return q;
+  return static_cast<mcPretty_pretty> (q);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -306,7 +300,7 @@ extern "C" mcPretty_pretty mcPretty_popPretty (mcPretty_pretty p)
 
 extern "C" unsigned int mcPretty_getindent (mcPretty_pretty p)
 {
-  return p->indent;
+  return static_cast<mcPretty_pretty__opaque> (p)->indent;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -318,7 +312,7 @@ extern "C" unsigned int mcPretty_getindent (mcPretty_pretty p)
 
 extern "C" void mcPretty_setindent (mcPretty_pretty p, unsigned int n)
 {
-  p->indent = n;
+  static_cast<mcPretty_pretty__opaque> (p)->indent = n;
 }
 
 
@@ -328,13 +322,13 @@ extern "C" void mcPretty_setindent (mcPretty_pretty p, unsigned int n)
 
 extern "C" unsigned int mcPretty_getcurpos (mcPretty_pretty s)
 {
-  if (s->needsSpace)
+  if (static_cast<mcPretty_pretty__opaque> (s)->needsSpace)
     {
-      return s->curPos+1;
+      return static_cast<mcPretty_pretty__opaque> (s)->curPos+1;
     }
   else
     {
-      return s->curPos;
+      return static_cast<mcPretty_pretty__opaque> (s)->curPos;
     }
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -347,7 +341,7 @@ extern "C" unsigned int mcPretty_getcurpos (mcPretty_pretty s)
 
 extern "C" unsigned int mcPretty_getseekpos (mcPretty_pretty s)
 {
-  return s->seekPos;
+  return static_cast<mcPretty_pretty__opaque> (s)->seekPos;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -359,7 +353,7 @@ extern "C" unsigned int mcPretty_getseekpos (mcPretty_pretty s)
 
 extern "C" unsigned int mcPretty_getcurline (mcPretty_pretty s)
 {
-  return s->curLine;
+  return static_cast<mcPretty_pretty__opaque> (s)->curLine;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -369,7 +363,7 @@ extern "C" void mcPretty_setNeedSpace (mcPretty_pretty s)
   /* 
    setneedSpace - sets needSpace flag to TRUE.
   */
-  s->needsSpace = true;
+  static_cast<mcPretty_pretty__opaque> (s)->needsSpace = true;
 }
 
 
@@ -379,7 +373,7 @@ extern "C" void mcPretty_setNeedSpace (mcPretty_pretty s)
 
 extern "C" void mcPretty_noSpace (mcPretty_pretty s)
 {
-  s->needsSpace = false;
+  static_cast<mcPretty_pretty__opaque> (s)->needsSpace = false;
 }
 
 
@@ -412,25 +406,25 @@ extern "C" void mcPretty_prints (mcPretty_pretty p, DynamicStrings_String s)
 
   l = DynamicStrings_Length (s);
   i = 0;
-  flushSpace (p);
+  flushSpace (static_cast<mcPretty_pretty__opaque> (p));
   while (i < l)
     {
       if ((((i+2) <= l) && ((DynamicStrings_char (s, static_cast<int> (i))) == '\\')) && ((DynamicStrings_char (s, static_cast<int> (i+1))) == 'n'))
         {
-          p->needsIndent = true;
-          p->needsSpace = false;
-          p->curPos = 0;
-          (*p->writeln.proc) ();
-          p->seekPos += 1;
-          p->curLine += 1;
+          static_cast<mcPretty_pretty__opaque> (p)->needsIndent = true;
+          static_cast<mcPretty_pretty__opaque> (p)->needsSpace = false;
+          static_cast<mcPretty_pretty__opaque> (p)->curPos = 0;
+          (*static_cast<mcPretty_pretty__opaque> (p)->writeln.proc) ();
+          static_cast<mcPretty_pretty__opaque> (p)->seekPos += 1;
+          static_cast<mcPretty_pretty__opaque> (p)->curLine += 1;
           i += 1;
         }
       else
         {
-          flushIndent (p);
-          (*p->write_.proc) (DynamicStrings_char (s, static_cast<int> (i)));
-          p->curPos += 1;
-          p->seekPos += 1;
+          flushIndent (static_cast<mcPretty_pretty__opaque> (p));
+          (*static_cast<mcPretty_pretty__opaque> (p)->write_.proc) (DynamicStrings_char (s, static_cast<int> (i)));
+          static_cast<mcPretty_pretty__opaque> (p)->curPos += 1;
+          static_cast<mcPretty_pretty__opaque> (p)->seekPos += 1;
         }
       i += 1;
     }
@@ -449,21 +443,21 @@ extern "C" void mcPretty_raw (mcPretty_pretty p, DynamicStrings_String s)
 
   l = DynamicStrings_Length (s);
   i = 0;
-  flushSpace (p);
-  flushIndent (p);
+  flushSpace (static_cast<mcPretty_pretty__opaque> (p));
+  flushIndent (static_cast<mcPretty_pretty__opaque> (p));
   while (i < l)
     {
-      (*p->write_.proc) (DynamicStrings_char (s, static_cast<int> (i)));
-      p->curPos += 1;
-      p->seekPos += 1;
+      (*static_cast<mcPretty_pretty__opaque> (p)->write_.proc) (DynamicStrings_char (s, static_cast<int> (i)));
+      static_cast<mcPretty_pretty__opaque> (p)->curPos += 1;
+      static_cast<mcPretty_pretty__opaque> (p)->seekPos += 1;
       i += 1;
     }
 }
 
-extern "C" void _M2_mcPretty_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcPretty_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcPretty_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcPretty_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcPrintf.cc b/gcc/m2/mc-boot/GmcPrintf.cc
index 3fd4117c92a..f95ee136e5f 100644
--- a/gcc/m2/mc-boot/GmcPrintf.cc
+++ b/gcc/m2/mc-boot/GmcPrintf.cc
@@ -36,9 +36,9 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcPrintf_H
 #define _mcPrintf_C
 
+#include "GmcPrintf.h"
 #   include "GSFIO.h"
 #   include "GFIO.h"
 #   include "GDynamicStrings.h"
@@ -167,7 +167,7 @@ static void cast (unsigned char *a, unsigned int _a_high, const unsigned char *b
     {
       for (i=0; i<=_a_high; i++)
         {
-          a[i] = b[i];
+          const_cast<unsigned char *>(a)[i] = b[i];
         }
     }
   else
@@ -199,7 +199,7 @@ static bool TranslateNameToCharStar (char *a, unsigned int _a_high, unsigned int
         {
           if ((a[i+1] == 'a') && (argno == n))
             {
-              a[i+1] = 's';
+              const_cast<char *>(a)[i+1] = 's';
               return true;
             }
           argno += 1;
@@ -647,10 +647,10 @@ extern "C" void mcPrintf_fprintf4 (FIO_File file, const char *a_, unsigned int _
     {}  /* empty.  */
 }
 
-extern "C" void _M2_mcPrintf_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcPrintf_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcPrintf_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcPrintf_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcQuiet.cc b/gcc/m2/mc-boot/GmcQuiet.cc
index ccff3b64b5a..b9d4e22110a 100644
--- a/gcc/m2/mc-boot/GmcQuiet.cc
+++ b/gcc/m2/mc-boot/GmcQuiet.cc
@@ -24,9 +24,9 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
        typedef struct { PROC_t proc; } PROC;
 #   endif
 
-#define _mcQuiet_H
 #define _mcQuiet_C
 
+#include "GmcQuiet.h"
 #   include "GmcOptions.h"
 #   include "GmcPrintf.h"
 
@@ -121,10 +121,10 @@ extern "C" void mcQuiet_qprintf4 (const char *a_, unsigned int _a_high, const un
     }
 }
 
-extern "C" void _M2_mcQuiet_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcQuiet_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcQuiet_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcQuiet_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcSearch.cc b/gcc/m2/mc-boot/GmcSearch.cc
index add9b820b33..7ebe597d67a 100644
--- a/gcc/m2/mc-boot/GmcSearch.cc
+++ b/gcc/m2/mc-boot/GmcSearch.cc
@@ -36,9 +36,9 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcSearch_H
 #define _mcSearch_C
 
+#include "GmcSearch.h"
 #   include "GSFIO.h"
 #   include "GmcFileName.h"
 #   include "GDynamicStrings.h"
@@ -399,11 +399,11 @@ extern "C" void mcSearch_setModExtension (DynamicStrings_String ext)
   Mod = DynamicStrings_Dup (ext);
 }
 
-extern "C" void _M2_mcSearch_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcSearch_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
   Init ();
 }
 
-extern "C" void _M2_mcSearch_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcSearch_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcStack.cc b/gcc/m2/mc-boot/GmcStack.cc
index c35fef32f11..11ff03e407f 100644
--- a/gcc/m2/mc-boot/GmcStack.cc
+++ b/gcc/m2/mc-boot/GmcStack.cc
@@ -31,16 +31,16 @@ Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcStack_H
 #define _mcStack_C
 
+#include "GmcStack.h"
 #   include "GStorage.h"
 #   include "GIndexing.h"
 #   include "GM2RTS.h"
 
 typedef struct mcStack__T1_r mcStack__T1;
 
-typedef mcStack__T1 *mcStack_stack;
+typedef mcStack__T1 *mcStack_stack__opaque;
 
 struct mcStack__T1_r {
                        Indexing_Index list;
@@ -101,12 +101,12 @@ extern "C" void * mcStack_access (mcStack_stack s, unsigned int i);
 
 extern "C" mcStack_stack mcStack_init (void)
 {
-  mcStack_stack s;
+  mcStack_stack__opaque s;
 
   Storage_ALLOCATE ((void **) &s, sizeof (mcStack__T1));
   s->list = Indexing_InitIndex (1);
   s->count = 0;
-  return s;
+  return static_cast<mcStack_stack> (s);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -118,9 +118,9 @@ extern "C" mcStack_stack mcStack_init (void)
 
 extern "C" void mcStack_kill (mcStack_stack *s)
 {
-  (*s)->list = Indexing_KillIndex ((*s)->list);
+  static_cast<mcStack_stack__opaque> ((*s))->list = Indexing_KillIndex (static_cast<mcStack_stack__opaque> ((*s))->list);
   Storage_DEALLOCATE ((void **) &(*s), sizeof (mcStack__T1));
-  (*s) = NULL;
+  (*s) = static_cast<mcStack_stack> (NULL);
 }
 
 
@@ -131,15 +131,15 @@ extern "C" void mcStack_kill (mcStack_stack *s)
 
 extern "C" void * mcStack_push (mcStack_stack s, void * a)
 {
-  if (s->count == 0)
+  if (static_cast<mcStack_stack__opaque> (s)->count == 0)
     {
-      Indexing_PutIndice (s->list, Indexing_LowIndice (s->list), a);
+      Indexing_PutIndice (static_cast<mcStack_stack__opaque> (s)->list, Indexing_LowIndice (static_cast<mcStack_stack__opaque> (s)->list), a);
     }
   else
     {
-      Indexing_PutIndice (s->list, (Indexing_HighIndice (s->list))+1, a);
+      Indexing_PutIndice (static_cast<mcStack_stack__opaque> (s)->list, (Indexing_HighIndice (static_cast<mcStack_stack__opaque> (s)->list))+1, a);
     }
-  s->count += 1;
+  static_cast<mcStack_stack__opaque> (s)->count += 1;
   return a;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -154,16 +154,16 @@ extern "C" void * mcStack_pop (mcStack_stack s)
 {
   void * a;
 
-  if (s->count == 0)
+  if (static_cast<mcStack_stack__opaque> (s)->count == 0)
     {
       M2RTS_HALT (-1);
       __builtin_unreachable ();
     }
   else
     {
-      s->count -= 1;
-      a = Indexing_GetIndice (s->list, Indexing_HighIndice (s->list));
-      Indexing_DeleteIndice (s->list, Indexing_HighIndice (s->list));
+      static_cast<mcStack_stack__opaque> (s)->count -= 1;
+      a = Indexing_GetIndice (static_cast<mcStack_stack__opaque> (s)->list, Indexing_HighIndice (static_cast<mcStack_stack__opaque> (s)->list));
+      Indexing_DeleteIndice (static_cast<mcStack_stack__opaque> (s)->list, Indexing_HighIndice (static_cast<mcStack_stack__opaque> (s)->list));
       return a;
     }
   ReturnException ("../../gcc/m2/mc/mcStack.def", 20, 1);
@@ -192,7 +192,7 @@ extern "C" void * mcStack_replace (mcStack_stack s, void * a)
 
 extern "C" unsigned int mcStack_depth (mcStack_stack s)
 {
-  return s->count;
+  return static_cast<mcStack_stack__opaque> (s)->count;
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -207,23 +207,23 @@ extern "C" unsigned int mcStack_depth (mcStack_stack s)
 
 extern "C" void * mcStack_access (mcStack_stack s, unsigned int i)
 {
-  if ((i > s->count) || (i == 0))
+  if ((i > static_cast<mcStack_stack__opaque> (s)->count) || (i == 0))
     {
       M2RTS_HALT (-1);
       __builtin_unreachable ();
     }
   else
     {
-      return Indexing_GetIndice (s->list, i);
+      return Indexing_GetIndice (static_cast<mcStack_stack__opaque> (s)->list, i);
     }
   ReturnException ("../../gcc/m2/mc/mcStack.def", 20, 1);
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcStack_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcStack_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcStack_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcStack_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcStream.cc b/gcc/m2/mc-boot/GmcStream.cc
index baf301aff61..3d8d01da465 100644
--- a/gcc/m2/mc-boot/GmcStream.cc
+++ b/gcc/m2/mc-boot/GmcStream.cc
@@ -42,9 +42,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcStream_H
 #define _mcStream_C
 
+#include "GmcStream.h"
 #   include "GFIO.h"
 #   include "Glibc.h"
 #   include "GIndexing.h"
@@ -264,13 +264,13 @@ extern "C" void mcStream_removeFiles (void)
   listOfFiles = alists_initList ();
 }
 
-extern "C" void _M2_mcStream_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcStream_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
   listOfFiles = alists_initList ();
   seenDest = false;
   frag = Indexing_InitIndex (1);
 }
 
-extern "C" void _M2_mcStream_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcStream_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gmcp1.cc b/gcc/m2/mc-boot/Gmcp1.cc
index c005fcbb7a3..b6b0f87a43a 100644
--- a/gcc/m2/mc-boot/Gmcp1.cc
+++ b/gcc/m2/mc-boot/Gmcp1.cc
@@ -41,9 +41,9 @@ see <https://www.gnu.org/licenses/>.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcp1_H
 #define _mcp1_C
 
+#include "Gmcp1.h"
 #   include "GDynamicStrings.h"
 #   include "GmcError.h"
 #   include "GnameKey.h"
@@ -1831,7 +1831,8 @@ static void DefinitionModule (mcp1_SetOfStop0 stopset0, mcp1_SetOfStop1 stopset1
                            
                            % n := makeType (curident)  %
                            ( ';' 
-                             % putTypeHidden (n)  %
+                             % putTypeHidden (n) ;
+                               putTypeOpaque (n)  %
                               | '=' Type Alignment 
                              ';'  )  } 
 
@@ -6955,7 +6956,8 @@ static void DefinitionModule (mcp1_SetOfStop0 stopset0, mcp1_SetOfStop1 stopset1
                            
                            % n := makeType (curident)  %
                            ( ';' 
-                             % putTypeHidden (n)  %
+                             % putTypeHidden (n) ;
+                               putTypeOpaque (n)  %
                               | '=' Type Alignment 
                              ';'  )  } 
 
@@ -6976,6 +6978,7 @@ static void DefTypeDeclaration (mcp1_SetOfStop0 stopset0, mcp1_SetOfStop1 stopse
         {
           Expect (mcReserved_semicolontok, stopset0, stopset1, stopset2|(mcp1_SetOfStop2) ((1 << (mcReserved_identtok-mcReserved_recordtok))));
           decl_putTypeHidden (n);
+          decl_putTypeOpaque (n);
         }
       else if (mcLexBuf_currenttoken == mcReserved_equaltok)
         {
@@ -7257,10 +7260,10 @@ extern "C" bool mcp1_CompilationUnit (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcp1_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp1_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcp1_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp1_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gmcp2.cc b/gcc/m2/mc-boot/Gmcp2.cc
index c5f32c1395e..f61e42220d4 100644
--- a/gcc/m2/mc-boot/Gmcp2.cc
+++ b/gcc/m2/mc-boot/Gmcp2.cc
@@ -41,9 +41,9 @@ see <https://www.gnu.org/licenses/>.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcp2_H
 #define _mcp2_C
 
+#include "Gmcp2.h"
 #   include "GDynamicStrings.h"
 #   include "GmcError.h"
 #   include "GnameKey.h"
@@ -7629,10 +7629,10 @@ extern "C" bool mcp2_CompilationUnit (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcp2_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp2_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcp2_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp2_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gmcp3.cc b/gcc/m2/mc-boot/Gmcp3.cc
index 096cdafbc64..e327d366b56 100644
--- a/gcc/m2/mc-boot/Gmcp3.cc
+++ b/gcc/m2/mc-boot/Gmcp3.cc
@@ -41,9 +41,9 @@ see <https://www.gnu.org/licenses/>.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcp3_H
 #define _mcp3_C
 
+#include "Gmcp3.h"
 #   include "GDynamicStrings.h"
 #   include "GmcError.h"
 #   include "GnameKey.h"
@@ -7846,10 +7846,10 @@ extern "C" bool mcp3_CompilationUnit (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcp3_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp3_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcp3_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp3_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gmcp4.cc b/gcc/m2/mc-boot/Gmcp4.cc
index 0cfbe9b243a..2fdd0ae2523 100644
--- a/gcc/m2/mc-boot/Gmcp4.cc
+++ b/gcc/m2/mc-boot/Gmcp4.cc
@@ -41,9 +41,9 @@ see <https://www.gnu.org/licenses/>.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcp4_H
 #define _mcp4_C
 
+#include "Gmcp4.h"
 #   include "GDynamicStrings.h"
 #   include "GmcError.h"
 #   include "GnameKey.h"
@@ -7709,10 +7709,10 @@ extern "C" bool mcp4_CompilationUnit (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcp4_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp4_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcp4_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp4_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gmcp5.cc b/gcc/m2/mc-boot/Gmcp5.cc
index 08de65334e8..d1e1fe984fa 100644
--- a/gcc/m2/mc-boot/Gmcp5.cc
+++ b/gcc/m2/mc-boot/Gmcp5.cc
@@ -41,9 +41,9 @@ see <https://www.gnu.org/licenses/>.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcp5_H
 #define _mcp5_C
 
+#include "Gmcp5.h"
 #   include "GDynamicStrings.h"
 #   include "GmcError.h"
 #   include "GnameKey.h"
@@ -5553,7 +5553,7 @@ static void SubDesignator (mcp5_SetOfStop0 stopset0, mcp5_SetOfStop1 stopset1, m
     {
       ErrorArray ((const char *) "no expression found", 19);
       mcError_flushErrors ();
-      return ;
+      return;
     }
   type = decl_skipType (decl_getType (n));
   if (mcLexBuf_currenttoken == mcReserved_periodtok)
@@ -8568,10 +8568,10 @@ extern "C" bool mcp5_CompilationUnit (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcp5_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp5_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcp5_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcp5_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GnameKey.cc b/gcc/m2/mc-boot/GnameKey.cc
index 2b236667ea1..ba9eaa026c0 100644
--- a/gcc/m2/mc-boot/GnameKey.cc
+++ b/gcc/m2/mc-boot/GnameKey.cc
@@ -43,9 +43,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #   undef NULL
 #   define NULL 0
 #endif
-#define _nameKey_H
 #define _nameKey_C
 
+#include "GnameKey.h"
 #   include "GSYSTEM.h"
 #   include "GStorage.h"
 #   include "GIndexing.h"
@@ -394,13 +394,13 @@ extern "C" void nameKey_getKey (nameKey_Name key, char *a, unsigned int _a_high)
   higha = _a_high;
   while (((p != NULL) && (i <= higha)) && ((*p) != ASCII_nul))
     {
-      a[i] = (*p);
+      const_cast<char *>(a)[i] = (*p);
       p += 1;
       i += 1;
     }
   if (i <= higha)
     {
-      a[i] = ASCII_nul;
+      const_cast<char *>(a)[i] = ASCII_nul;
     }
 }
 
@@ -572,7 +572,7 @@ extern "C" void * nameKey_keyToCharStar (nameKey_Name key)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_nameKey_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_nameKey_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
   lastIndice = 0;
   keyIndex = Indexing_InitIndex (1);
@@ -580,6 +580,6 @@ extern "C" void _M2_nameKey_init (__attribute__((unused)) int argc,__attribute__
   binaryTree->left = NULL;
 }
 
-extern "C" void _M2_nameKey_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_nameKey_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
